package edu.upvehu.gbg.docencia.perfectos;

/**
 * Proporciona 2 alternativas para mostrar los números perfectos hasta un tope dado comprobando la suma de sus divisores.
 * De utilidad para ver cómo el planteamiento de algoritmos adecuados es importante,
 * 
 * @author german
 */
public class PerfectosConSumas {
    //Anulamos la posibilidad de construir objetos. Es una maleta.
    private PerfectosConSumas(){}
    
//----------   METODO NAIF    -------------------------------------------
    
   /**
     * Muestra en la salida estándar los perfectos hasta "max",
     * probando para cada uno de ellos todos sus divisores.
     * 
     * @param max número superior a considerar
     */
    public static void perfectosNaif(long max){
    for (long candidato=1; candidato<=max; candidato++) {
        long suma=0;
        for (long divisor=1 ;divisor<candidato;divisor++) if (candidato%divisor==0) suma+=divisor;        
        if (candidato==suma) System.out.println(candidato);
    }
}
    
    //----------   METODO MEJOR   -------------------------------------------
    
   /**
     * Muestra en la salida estándar los perfectos hasta "max",
     * probando para cada uno los divisores hasta su raíz cuadrada y sumando los encontrados y sus complementarios.
     * 
     * @param max número superior a considerar
     */
    public static void perfectosMejor(long max){
        for (long candidato=1; candidato<max; candidato++) {
            long suma=1;
            for (int divisor=2;divisor<=Math.sqrt(candidato);divisor++) if (candidato%divisor==0) suma+=divisor+candidato/divisor;        
            if (candidato==suma) System.out.println(candidato);
        }
    }
 
}
