/*
 * Copyright (C) 2024 German
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package edu.upvehu.gbg.docencia.perfectos;

import static org.junit.Assert.*;
import org.junit.Test;

public class PrimesTest {

    @Test
    public void testIsPrime() {
        assertTrue(Primes.isPrime(2));
        assertTrue(Primes.isPrime(3));
        assertTrue(Primes.isPrime(5));
        assertTrue(Primes.isPrime(7));
        assertTrue(Primes.isPrime(11));
        assertFalse(Primes.isPrime(1));
        assertFalse(Primes.isPrime(4));
        assertFalse(Primes.isPrime(10));
    }

    @Test
    public void testPrimeGenerator() {
        Primes.PrimeGenerator generator = new Primes.PrimeGenerator();
        assertEquals(2, generator.nextPrime());
    }

    @Test
    public void testPrimeGeneratorFrom() {
        Primes.PrimeGenerator generator = new Primes.PrimeGenerator(5);
        assertEquals(7, generator.nextPrime());
        assertEquals(11, generator.nextPrime());
        assertEquals(13, generator.nextPrime());

        
        generator = new Primes.PrimeGenerator(9);
        assertEquals(11, generator.nextPrime());

    }

//    @Test
//    public void testAddNextToList() {
//        Primes.PrimeGenerator generator = new Primes.PrimeGenerator();
//        generator.nextPrime(); // 2
//        generator.nextPrime(); // 3
//        generator.nextPrime(); // 5
//        generator.nextPrime(); // 7
//        generator.nextPrime(); // 11
//        Primes.addNextToList();
//        assertTrue(Primes.isPrime(13)); // 13 es el siguiente primo que debería ser añadido
//    }
}
